Index: issm/trunk/src/m/classes/clusters/stallo.m
===================================================================
--- issm/trunk/src/m/classes/clusters/stallo.m	(revision 23394)
+++ issm/trunk/src/m/classes/clusters/stallo.m	(revision 23394)
@@ -0,0 +1,218 @@
+%        Stallo cluster class definition
+%	        This is a SLURM queue
+%	        The priorities are given to:
+%	           - Large jobs
+%	           - Short jobs
+%	           - small number of job per user
+%
+%	        There are some 20cpu nodes and 16cpu nodes, with 32GB (a few with 128GB) mem per node, you can ask for part of a node if you need more memory.(1 node, 2 CPUS and 10GB per cpu for example)
+
+%   Usage:
+%      cluster=stallo();
+%      cluster=stallo('np',3);
+%      cluster=stallo('np',3,'login','username');
+
+%node task and cpu must be defined, ask andreas for his stallo.py?
+
+classdef stallo
+    properties (SetAccess=public)
+		 % {{{
+		 name           = 'stallo';
+		 login          = '';
+		 numnodes       = 2;
+		 cpuspernode    = 10;
+		 mem            = 1.5;
+		 queue          = 'normal';
+		 time           = 2*60;
+		 codepath       = '';
+		 executionpath  = '';
+		 interactive    = 0;
+		 port           = [];
+		 accountname    = '';
+		 profiling	= 0;
+		 bbftp          = 0;
+		 % }}}
+	 end
+	 methods
+		 function cluster=stallo(varargin) % {{{
+
+			 %initialize cluster using default settings if provided
+			 if (exist('stallo_settings')==2), stallo_settings; end
+
+			 %use provided options to change fields
+			 cluster=AssignObjectFields(pairoptions(varargin{:}),cluster);
+		 end
+		 %}}}
+		 function disp(cluster) % {{{
+			 %  display the object
+			 disp(sprintf('class ''%s'' object ''%s'' = ',class(cluster),inputname(1)));
+			 disp(sprintf('    name: %s',cluster.name));
+			 disp(sprintf('    login: %s',cluster.login));
+       disp(sprintf('    accountname: %s',cluster.accountname));
+			 disp(sprintf('    numnodes: %i',cluster.numnodes));
+			 disp(sprintf('    cpuspernode: %i, cpu per nodes',cluster.cpuspernode));
+			 disp(sprintf('    queue: %s, name of the queue (normal (D), short,singlenode,multinode,devel)',cluster.queue));
+			 disp(sprintf('    codepath: %s',cluster.codepath));
+			 disp(sprintf('    executionpath: %s',cluster.executionpath));
+			 disp(sprintf('    interactive: %i',cluster.interactive));
+			 disp(sprintf('    time: %i, walltime requested in minutes',cluster.time));
+			 disp(sprintf('    memory: %i, memory per CPU',cluster.mem));
+			 disp(sprintf('    profiling: %i, enable profiling if 1 default is 0',cluster.profiling));
+		 end
+		 %}}}
+		 function md = checkconsistency(cluster,md,solution,analyses) % {{{
+
+			 available_queues={'short','normal','singlenode','multinode','devel'};
+			 queue_requirements_time=[60 2*24*60 28*24*60 28*24*60 4*60];
+			 queue_requirements_np=[2048 2048 20 2048 2048];
+
+			 QueueRequirements(available_queues,queue_requirements_time,queue_requirements_np,cluster.queue,cluster.np,1)
+
+			 %Miscelaneous
+			 if isempty(cluster.login), md = checkmessage(md,'login empty'); end
+       if isempty(cluster.accountname), md = checkmessage(md,'accountname empty'); end
+			 if isempty(cluster.codepath), md = checkmessage(md,'codepath empty'); end
+			 if isempty(cluster.executionpath), md = checkmessage(md,'executionpath empty'); end
+
+		 end
+		 %}}}
+		 function numprocs=np(cluster) % {{{
+			 %compute number of processors
+			 numprocs=cluster.numnodes*cluster.cpuspernode;
+		 end
+		 %}}}
+		 function BuildQueueScript(cluster,dirname,modelname,solution,io_gather,isvalgrind,isgprof,isdakota,isoceancoupling) % {{{
+
+			 if(isvalgrind), disp('valgrind not supported by cluster, ignoring...'); end
+			 if(isgprof),    disp('gprof not supported by cluster, ignoring...'); end
+
+			 executable='issm.exe';
+			 if isdakota,
+				 version=IssmConfig('_DAKOTA_VERSION_'); version=str2num(version(1:3));
+				 if (version>=6),
+					 executable='issm_dakota.exe';
+				 end
+			 end
+			 if isoceancoupling,
+				 executable='issm_ocean.exe';
+			 end
+
+			 days=floor(cluster.time/(60*24));
+			 hours=floor((cluster.time-(days*60*24))/60);
+			 minutes=floor(mod((cluster.time-(days*60*24)-(hours*60)),60));
+
+			 %write queuing script
+			 fid=fopen([modelname '.queue'],'w');
+			 fprintf(fid,'#!/bin/bash -l\n');
+			 fprintf(fid,'#SBATCH --job-name=%s \n',modelname);
+			 fprintf(fid,'#SBATCH --qos=%s \n',cluster.queue);
+			 fprintf(fid,'#SBATCH --nodes=%i \n',cluster.numnodes);
+			 fprintf(fid,'#SBATCH --ntasks-per-node=%i \n',cluster.cpuspernode);
+			 fprintf(fid,'#SBATCH --time=%02i-%02i:%02i:00 \n',days,hours,minutes);
+			 fprintf(fid,'#SBATCH --mem-per-cpu=%iMB\n',1000*cluster.mem); % mem in MB
+			 if (mod(cluster.np,16)+mod(cluster.np,20))==0,
+			 	fprintf(fid,'#SBATCH --ntask=%i\n',cluster.np);
+			 end
+			 fprintf(fid,'#SBATCH --account=%s\n',cluster.accountname);
+ 			 fprintf(fid,'#SBATCH --output %s/%s/%s.outlog \n',cluster.executionpath,dirname,modelname);
+ 			 fprintf(fid,'#SBATCH --error %s/%s/%s.errlog \n\n',cluster.executionpath,dirname,modelname);
+
+ 			 fprintf(fid,'export ISSM_DIR="%s/../"\n',cluster.codepath);%FIXME
+ 			 fprintf(fid,'module purge\n');
+ 			 fprintf(fid,'module load CMake/3.8.0-GCCcore-6.3.0\n');
+ 			 fprintf(fid,'module load Automake/1.15.1-GCCcore-6.3.0\n');
+ 			 fprintf(fid,'module load libtool/2.4.6\n');
+ 			 fprintf(fid,'module load OpenSSL/1.1.0e-intel-2017a\n');
+ 			 fprintf(fid,'module load PETSc/3.7.5-intel-2017a-downloaded-deps\n');
+
+ 			 fprintf(fid,'cd %s/%s/\n\n',cluster.executionpath,dirname);
+			 if cluster.profiling==1,
+			 	fprintf(fid,'module load perf-report\n');
+			 	fprintf(fid,'perf-report mpirun -np %i %s/%s %s %s/%s %s\n',cluster.np,cluster.codepath,executable,solution,cluster.executionpath,dirname,modelname);
+			 else
+			 	fprintf(fid,'mpirun -np %i %s/%s %s %s/%s %s\n',cluster.np,cluster.codepath,executable,solution,cluster.executionpath,dirname,modelname);
+			 end
+			 %}}}
+			 if ~io_gather, %concatenate the output files:
+				 fprintf(fid,'cat %s.outbin.* > %s.outbin',modelname,modelname);
+			 end
+			 fclose(fid);
+
+			 %in interactive mode, create a run file, and errlog and outlog file
+			 if cluster.interactive,
+			 	 fid=fopen([modelname '.run'],'w');
+			 	 fprintf(fid,'mpiexec -np %i %s/issm.exe %s %s %s\n',cluster.np,cluster.codepath,solution,[cluster.executionpath '/' dirname],modelname);
+		 	 	 if ~io_gather, %concatenate the output files:
+			 		 fprintf(fid,'cat %s.outbin.* > %s.outbin',modelname,modelname);
+			 	 end
+			 	 fclose(fid);
+			 	 fid=fopen([modelname '.errlog'],'w');
+			 	 fclose(fid);
+			 	 fid=fopen([modelname '.outlog'],'w');
+			 	 fclose(fid);
+			 end
+		 end
+
+
+		 function UploadQueueJob(cluster,modelname,dirname,filelist)% {{{
+
+			 %compress the files into one zip.
+			 compressstring=['tar -zcf ' dirname '.tar.gz '];
+			 for i=1:numel(filelist),
+				 compressstring = [compressstring ' ' filelist{i}];
+			 end
+			 if cluster.interactive,
+				 compressstring = [compressstring ' ' modelname '.run '  modelname '.errlog ' modelname '.outlog '];
+			 end
+			 system(compressstring);
+			 disp('uploading input file and queueing script');
+			 if cluster.interactive==10,
+				 directory=[pwd() '/run/'];
+			 elseif cluster.interactive,
+				 directory=[cluster.executionpath '/Interactive' num2str(cluster.interactive)];
+			 else
+				 directory=cluster.executionpath;
+			 end
+
+			 if ~cluster.bbftp,
+				 issmscpout(cluster.name,directory,cluster.login,cluster.port,{[dirname '.tar.gz']});
+			 else
+				 issmbbftpout(cluster.name,directory,cluster.login,cluster.port,cluster.numstreams,{[dirname '.tar.gz']});
+
+			 end
+		 end %}}}
+		 function LaunchQueueJob(cluster,modelname,dirname,filelist,restart,batch)% {{{
+
+			 %lauch command, to be executed via ssh
+			 if ~cluster.interactive,
+				 if ~isempty(restart)
+					 launchcommand=['cd ' cluster.executionpath ' && cd ' dirname ' && qsub ' modelname '.queue '];
+				 else
+					 launchcommand=['cd ' cluster.executionpath ' && rm -rf ./' dirname ' && mkdir ' dirname ...
+						 ' && cd ' dirname ' && mv ../' dirname '.tar.gz ./ && tar -zxf ' dirname '.tar.gz  && qsub ' modelname '.queue '];
+				 end
+			 else
+				 if ~isempty(restart)
+					 launchcommand=['cd ' cluster.executionpath '/Interactive' num2str(cluster.interactive)];
+				 else
+					 if cluster.interactive==10,
+						 launchcommand=['cd ' pwd() '/run && tar -zxf ' dirname '.tar.gz'];
+					 else
+						 launchcommand=['cd ' cluster.executionpath '/Interactive' num2str(cluster.interactive) ' && tar -zxf ' dirname '.tar.gz'];
+					 end
+				 end
+			 end
+
+			 disp('launching solution sequence on remote cluster');
+			 issmssh(cluster.name,cluster.login,cluster.port,launchcommand);
+		 end
+		 %}}}
+		 function Download(cluster,dirname,filelist)% {{{
+
+			 %copy files from cluster to current directory
+			 directory=[cluster.executionpath '/' dirname '/'];
+			 issmscpin(cluster.name,cluster.login,cluster.port,directory,filelist);
+
+		 end %}}}
+	end
+end
Index: issm/trunk/src/m/classes/clusters/stallo.py
===================================================================
--- issm/trunk/src/m/classes/clusters/stallo.py	(revision 23389)
+++ issm/trunk/src/m/classes/clusters/stallo.py	(revision 23394)
@@ -12,10 +12,10 @@
 except ImportError:
 	print 'You need stallo_settings.py to proceed, check presence and sys.path'
-	
+
 class stallo(object):
 	"""
 	Stallo cluster class definition
 	This is a SLURM queue
-	The priorities are given to: 
+	The priorities are given to:
 	   - Large jobs
 	   - Short jobs
@@ -23,5 +23,5 @@
 
 	There are some 20cpu nodes and 16cpu nodes, with 32GB (a few with 128GB) mem per node, you can ask for part of a node if you need more memory.(1 node, 2 CPUS and 10GB per cpu for example)
-	
+
 
 	   Usage:
@@ -51,7 +51,7 @@
 		#OK get other fields
 		self=options.AssignObjectFields(self)
-		self.np=self.numnodes*self.cpuspernode		
+		self.np=self.numnodes*self.cpuspernode
 	# }}}
-	
+
 	def __repr__(self):
 	# {{{
@@ -61,5 +61,5 @@
 		s = "%s\n%s"%(s,fielddisplay(self,'login','login'))
 		s = "%s\n%s"%(s,fielddisplay(self,'numnodes','number of nodes'))
-		s = "%s\n%s"%(s,fielddisplay(self,'cpuspernode','number of nodes per CPUs'))
+		s = "%s\n%s"%(s,fielddisplay(self,'cpuspernode','number of CPUs per nodes'))
 		s = "%s\n%s"%(s,fielddisplay(self,'mem','memory per CPU'))
 		s = "%s\n%s"%(s,fielddisplay(self,'queue','name of the queue (normal (D), short,singlenode,multinode,devel)'))
@@ -104,18 +104,23 @@
 		if isoceancoupling:
 			executable='issm_ocean.exe'
-		#write queuing script 
+		#write queuing script
 		shortname=modelname[0:min(12,len(modelname))]
+		timeobj=datetime.timedelta(minutes=self.time)
+		m,s=divmod(timeobj.total_seconds(), 60)
+		h,m=divmod(m, 60)
+		d,h=divmod(h, 60)
+		timestring="%02d-%02d:%02d:%02d" % (d, h, m, s)
+
 		fid=open(modelname+'.queue','w')
-									
 		fid.write('#!/bin/bash -l\n')
 		fid.write('#SBATCH --job-name=%s \n' % shortname)
-		fid.write('#SBATCH --partition %s \n' % self.queue)
-		fid.write('#SBATCH --nodes=%i' % self.numnodes)
-		fid.write('#SBATCH --ntasks-per-nodes==%i \n' % self.cpuspernode)									
-		fid.write('#SBATCH --time=%s\n' % self.time) #walltime is minutes
-		fid.write('#SBATCH --mem-per-cpu=%iGB\n' % self.mem)# mem is in GB
+		fid.write('#SBATCH --qos=%s \n' % self.queue)
+		fid.write('#SBATCH --nodes=%i \n' % self.numnodes)
+		fid.write('#SBATCH --ntasks-per-node=%i \n' % self.cpuspernode)
+		fid.write('#SBATCH --time={}\n'.format(timestring)) #walltime is minutes
+		fid.write('#SBATCH --mem-per-cpu={}MB\n'.format(int(1000*self.mem)))# mem is in MB
 		if (np.mod(self.np,16)+np.mod(self.np,20))==0:
 			fid.write('#SBATCH --ntask=%i\n' % self.np)
-		fid.write('#SBATCH --account=%s\n' % self.accountname) 
+		fid.write('#SBATCH --account=%s\n' % self.accountname)
 		fid.write('#SBATCH --output %s/%s/%s.outlog \n' % (self.executionpath,dirname,modelname))
 		fid.write('#SBATCH --error %s/%s/%s.errlog \n\n' % (self.executionpath,dirname,modelname))
Index: issm/trunk/src/m/classes/clusters/tetralith.m
===================================================================
--- issm/trunk/src/m/classes/clusters/tetralith.m	(revision 23394)
+++ issm/trunk/src/m/classes/clusters/tetralith.m	(revision 23394)
@@ -0,0 +1,216 @@
+%teralith class definition
+%
+%   Usage:
+%      cluster=tetralith();
+%      cluster=tetralith('np',3);
+%      cluster=tetralith('np',3,'login','username');
+
+classdef tetralith
+	properties (SetAccess=public)  
+		% {{{
+		name           = 'tetralith';
+		login          = '';
+		numnodes       = 2;
+		cpuspernode    = 32;
+		mem            = 2000; %MB
+		queue          = 'normal';
+		time           = 2*60; %[minutes]
+		codepath       = '';
+		executionpath  = '';
+		interactive    = 0;
+		port           = [];
+		accountname    = '';
+		% }}}
+	end
+	methods
+		function cluster=tetralith(varargin) % {{{
+
+			%initialize cluster using default settings if provided
+			if (exist('tetralith_settings')==2), tetralith_settings; end
+
+			%use provided options to change fields
+			cluster=AssignObjectFields(pairoptions(varargin{:}),cluster);
+		end
+		%}}}
+		function disp(cluster) % {{{
+			%  display the object
+			disp(sprintf('class ''%s'' object ''%s'' = ',class(cluster),inputname(1)));
+			disp(sprintf('    name: %s',cluster.name));
+			disp(sprintf('    login: %s',cluster.login));
+			disp(sprintf('    accountname: %s',cluster.accountname));
+			disp(sprintf('    numnodes: %i',cluster.numnodes));
+			disp(sprintf('    cpuspernode: %i',cluster.cpuspernode));
+			disp(sprintf('    np: %i', cluster.cpuspernode*cluster.numnodes));
+			disp(sprintf('    queue: %s',cluster.queue));
+			disp(sprintf('    codepath: %s',cluster.codepath));
+			disp(sprintf('    executionpath: %s',cluster.executionpath));
+			disp(sprintf('    interactive: %i',cluster.interactive));
+			disp(sprintf('    time: %i',cluster.time));
+			disp(sprintf('    memory: %i',cluster.mem));
+		end
+		%}}}
+		function md = checkconsistency(cluster,md,solution,analyses) % {{{
+
+			available_queues={'normal','devel'};
+			queue_requirements_time=[7*24*60 60]; 
+			queue_requirements_np=[1024 2*32];
+
+			QueueRequirements(available_queues,queue_requirements_time,queue_requirements_np,cluster.queue,cluster.np,1)
+
+			%Miscelaneous
+			if isempty(cluster.login), md = checkmessage(md,'login empty'); end
+			if isempty(cluster.accountname), md = checkmessage(md,'accountname empty'); end
+			if isempty(cluster.codepath), md = checkmessage(md,'codepath empty'); end
+			if isempty(cluster.executionpath), md = checkmessage(md,'executionpath empty'); end
+
+		end
+		%}}}
+		function numprocs=np(self) % {{{
+			%compute number of processors
+			numprocs=self.numnodes*self.cpuspernode;
+		end
+		%}}}
+		function BuildKrigingQueueScript(cluster,modelname,solution,io_gather,isvalgrind,isgprof) % {{{
+
+			if(isvalgrind), disp('valgrind not supported by cluster, ignoring...'); end
+			if(isgprof),    disp('gprof not supported by cluster, ignoring...'); end
+
+			%compute number of processors
+% 			cluster.np=cluster.numnodes*cluster.cpuspernode;
+			np(cluster);%=cluster.numnodes*cluster.cpuspernode;
+
+			%write queuing script 
+			fid=fopen([modelname '.queue'],'w');
+			fprintf(fid,'#!/bin/bash\n');
+			fprintf(fid,'#\n');
+			fprintf(fid,'#SBATCH --job-name=%s\n',modelname);
+% 			fprintf(fid,'#SBATCH -p %s \n',cluster.partition);
+			fprintf(fid,'#SBATCH -A %s \n',cluster.accountname);
+% 			fprintf(fid,'#SBATCH --mail-type=ALL\n');
+			fprintf(fid,'#SBATCH -N %i -n %i\n',cluster.numnodes,cluster.cpuspernode);
+			%calculate walltime in hh:mm:ss format
+			walltime=datestr(cluster.time/(60*24),'HH:MM:SS')
+			fprintf(fid,'#SBATCH -t %s\n',walltime); %walltime should be in hh:mm:ss
+			fprintf(fid,'#SBATCH --mem=%i\n',cluster.mem);
+			fprintf(fid,'#SBATCH -o %s.outlog \n',modelname);
+			fprintf(fid,'#SBATCH -e %s.errlog \n\n',modelname);
+% 			fprintf(fid,'module load intelcomp/17.0.0\n') %module load not recommended within job script at Tetralith
+% 			fprintf(fid,'module load mpt/2.14\n')
+% 			fprintf(fid,'module load petsc/3.7.4d\n')
+% 			fprintf(fid,'module load parmetis/4.0.3\n') 
+% 			fprintf(fid,'module load mumps/5.0.2\n')
+% 			fprintf(fid,'export ISSM_DIR="%s"\n',cluster.codepath); %FIXME
+			fprintf(fid,'export ISSM_DIR="%s/../"\n',cluster.codepath); %FIXME
+			fprintf(fid,'source $ISSM_DIR/etc/environment.sh\n');       %FIXME
+			fprintf(fid,'cd %s/%s\n\n',cluster.executionpath,dirname);
+% 			fprintf(fid,'mpiexec -np %i %s/%s %s %s %s\n',cluster.np,cluster.codepath,executable,solution,[cluster.executionpath '/' dirname],modelname);
+% 			fprintf(fid,'mpiexec_mpt -np %i %s/%s %s %s %s\n',cluster.np,cluster.codepath,executable,solution,[cluster.executionpath '/' dirname],modelname);
+			 fprintf(fid,'mpiexec -np %i %s/issm.exe %s %s %s\n',cluster.np,cluster.codepath,solution,[cluster.executionpath '/' dirname],modelname);
+% 			fprintf(fid,'mpirun -np %i %s/issm.exe %s %s %s\n',cluster.np,cluster.codepath,solution,[cluster.executionpath '/' dirname],modelname);
+			 if ~io_gather, %concatenate the output files:
+				 fprintf(fid,'cat %s.outbin.* > %s.outbin',modelname,modelname);
+			 end
+			 fclose(fid);
+		end
+		%}}}
+		function BuildQueueScript(cluster,dirname,modelname,solution,io_gather,isvalgrind,isgprof,isdakota,isoceancoupling) % {{{
+
+			if(isvalgrind), disp('valgrind not supported by cluster, ignoring...'); end
+			if(isgprof),    disp('gprof not supported by cluster, ignoring...'); end
+
+			executable='issm.exe';
+			if isdakota,
+				version=IssmConfig('_DAKOTA_VERSION_'); version=str2num(version(1:3));
+				if (version>=6),
+					executable='issm_dakota.exe';
+				end
+			end
+			if isoceancoupling,
+				executable='issm_ocean.exe';
+			end
+
+			%compute number of processors
+% 			cluster.np=cluster.numnodes*cluster.cpuspernode;
+			np(cluster);%=cluster.numnodes*cluster.cpuspernode;                     
+% 			shortname = substring(modelname,1,min(12,length(modelname)));
+
+			%write queuing script 
+			fid=fopen([modelname '.queue'],'w');
+			fprintf(fid,'#!/bin/bash\n');
+			fprintf(fid,'#\n');
+			fprintf(fid,'#SBATCH --job-name=%s\n',modelname);
+% 			fprintf(fid,'#SBATCH -p %s \n',cluster.partition);
+			fprintf(fid,'#SBATCH -A %s \n',cluster.accountname);
+% 			fprintf(fid,'#SBATCH --mail-type=ALL\n');
+			fprintf(fid,'#SBATCH -N %i -n %i\n',cluster.numnodes,cluster.cpuspernode);
+			%calculate walltime in hh:mm:ss format
+			walltime=datestr(cluster.time/(60*24),'HH:MM:SS');
+			fprintf(fid,'#SBATCH -t %s\n',walltime); %walltime should be in hh:mm:ss
+			fprintf(fid,'#SBATCH --mem=%i\n',cluster.mem);
+			fprintf(fid,'#SBATCH -o %s.outlog \n',modelname);
+			fprintf(fid,'#SBATCH -e %s.errlog \n\n',modelname);
+% 			fprintf(fid,'module load intelcomp/17.0.0\n') %module load not recommended within job script at Tetralith
+% 			fprintf(fid,'module load mpt/2.14\n')
+% 			fprintf(fid,'module load petsc/3.7.4d\n')
+% 			fprintf(fid,'module load parmetis/4.0.3\n') 
+% 			fprintf(fid,'module load mumps/5.0.2\n')
+			fprintf(fid,'export ISSM_DIR="%s/../"\n',cluster.codepath); %FIXME
+% 			fprintf(fid,'export ISSM_DIR="%s"\n',cluster.codepath); %FIXME
+			fprintf(fid,'source $ISSM_DIR/etc/environment.sh\n');       %FIXME
+			fprintf(fid,'cd %s/%s\n\n',cluster.executionpath,dirname);
+% 			fprintf(fid,'mpiexec -np %i %s/%s %s %s %s\n',cluster.np,cluster.codepath,executable,solution,[cluster.executionpath '/' dirname],modelname);
+			 fprintf(fid,'mpiexec -np %i %s/issm.exe %s %s %s\n',cluster.np,cluster.codepath,solution,[cluster.executionpath '/' dirname],modelname);
+% 			fprintf(fid,'mpirun -np %i %s/issm.exe %s %s %s\n',cluster.np,cluster.codepath,solution,[cluster.executionpath '/' dirname],modelname);
+% 			fprintf(fid,'mpiexec_mpt -np %i %s/%s %s %s %s\n',cluster.np,cluster.codepath,executable,solution,[cluster.executionpath '/' dirname],modelname);
+
+			if ~io_gather, %concatenate the output files:
+				fprintf(fid,'cat %s.outbin.* > %s.outbin',modelname,modelname);
+			end
+			fclose(fid);
+
+			%in interactive mode, create a run file, and errlog and outlog file
+			if cluster.interactive,
+				fid=fopen([modelname '.run'],'w');
+				fprintf(fid,'mpiexec_mpt -np %i %s/issm.exe %s %s %s\n',cluster.np,cluster.codepath,solution,[cluster.executionpath '/' dirname],modelname);
+				if ~io_gather, %concatenate the output files:
+					fprintf(fid,'cat %s.outbin.* > %s.outbin',modelname,modelname);
+				end
+				fclose(fid);
+				fid=fopen([modelname '.errlog'],'w');
+				fclose(fid);
+				fid=fopen([modelname '.outlog'],'w');
+				fclose(fid);
+			end
+		end %}}}
+		function UploadQueueJob(cluster,modelname,dirname,filelist)% {{{
+
+			%compress the files into one zip.
+			compressstring=['tar -zcf ' dirname '.tar.gz '];
+			for i=1:numel(filelist),
+				compressstring = [compressstring ' ' filelist{i}];
+			end
+			system(compressstring);
+			disp('uploading input file and queueing script');
+			directory=cluster.executionpath;
+% 			issmbbftpout(cluster.name,directory,cluster.login,cluster.port,cluster.numstreams,{[dirname '.tar.gz']});
+			issmscpout(cluster.name,directory,cluster.login,cluster.port,{[dirname '.tar.gz']});
+
+		end
+		%}}}
+		function LaunchQueueJob(cluster,modelname,dirname,filelist,restart,batch)% {{{
+
+			disp('launching solution sequence on remote cluster');
+			launchcommand=['cd ' cluster.executionpath ' && rm -rf ./' dirname ' && mkdir ' dirname ...
+				' && cd ' dirname ' && mv ../' dirname '.tar.gz ./ && tar -zxf ' dirname '.tar.gz  && hostname && sbatch ' modelname '.queue '];
+
+			issmssh(cluster.name,cluster.login,cluster.port,launchcommand);
+		end %}}}
+		function Download(cluster,dirname,filelist)% {{{
+
+			%copy files from cluster to current directory
+			directory=[cluster.executionpath '/' dirname '/'];
+			issmscpin(cluster.name,cluster.login,cluster.port,directory,filelist);
+
+		end %}}}
+	end
+end
Index: issm/trunk/src/m/classes/groundingline.js
===================================================================
--- issm/trunk/src/m/classes/groundingline.js	(revision 23389)
+++ issm/trunk/src/m/classes/groundingline.js	(revision 23394)
@@ -29,5 +29,5 @@
 			checkfield(md,'fieldname','groundingline.melt_interpolation','values',['NoMeltOnPartiallyFloating', 'SubelementMelt1', 'SubelementMelt2', 'FullMeltOnPartiallyFloating']);
 
-			if (this.migration !='None'){
+			if(this.migration !='None' & md.trans.isgroundingline==1 & solution == 'TransientSolution'){
 				if (isNaN(md.geometry.bed)){
 					md.checkmessage('requesting grounding line migration, but bathymetry is absent!');
Index: issm/trunk/src/m/classes/groundingline.m
===================================================================
--- issm/trunk/src/m/classes/groundingline.m	(revision 23389)
+++ issm/trunk/src/m/classes/groundingline.m	(revision 23394)
@@ -33,5 +33,5 @@
 			md = checkfield(md,'fieldname','groundingline.melt_interpolation','values',{'NoMeltOnPartiallyFloating' 'SubelementMelt1' 'SubelementMelt2' 'FullMeltOnPartiallyFloating'});
 
-			if ~strcmp(self.migration,'None'),
+			if ~strcmp(self.migration,'None') & strcmp(solution,'TransientSolution') & md.transient.isgroundingline==1,
 				if isnan(md.geometry.bed),
 					md = checkmessage(md,['requesting grounding line migration, but bathymetry is absent!']);
Index: issm/trunk/src/m/classes/groundingline.py
===================================================================
--- issm/trunk/src/m/classes/groundingline.py	(revision 23389)
+++ issm/trunk/src/m/classes/groundingline.py	(revision 23394)
@@ -45,5 +45,5 @@
 		md = checkfield(md,'fieldname','groundingline.melt_interpolation','values',['SubelementMelt1','SubelementMelt2','NoMeltOnPartiallyFloating','FullMeltOnPartiallyFloating'])
 
-		if not m.strcmp(self.migration,'None'):
+		if(not m.strcmp(self.migration,'None') and md.transient.isgroundingline and solution=='TransientSolution'):
 			if np.any(np.isnan(md.geometry.bed)):
 				md.checkmessage("requesting grounding line migration, but bathymetry is absent!")
Index: issm/trunk/src/m/classes/numberedcostfunction.m
===================================================================
--- issm/trunk/src/m/classes/numberedcostfunction.m	(revision 23389)
+++ issm/trunk/src/m/classes/numberedcostfunction.m	(revision 23394)
@@ -1,3 +1,3 @@
-%M1QN3INVERSION class definition
+%NUMBEREDCOSTFUNCTION class definition
 %
 %   Usage:
@@ -44,18 +44,18 @@
 		function md = checkconsistency(self,md,solution,analyses) % {{{
 
-			num_costfunc=size(md.inversion.cost_functions,2);
+			num_costfunc=size(self.cost_functions,2);
 
-			md = checkfield(md,'fieldname','inversion.cost_functions','size',[1 num_costfunc],'values',supportedcostfunctions());
-			md = checkfield(md,'fieldname','inversion.cost_functions_coefficients','size',[md.mesh.numberofvertices num_costfunc],'>=',0);
-
+			md = checkfield(md,'fieldname','md.outputdefinition.definition{X}.dependent{X}.cost_functions','field',self.cost_functions,'size',[1 num_costfunc],'values',supportedcostfunctions());
+			md = checkfield(md,'fieldname','md.outputdefinition.definition{X}.cost_functions_coefficients','field',self.cost_functions_coefficients,'size',[md.mesh.numberofvertices numel(self.cost_functions)],'>=',0);
+			
 			if strcmp(solution,'BalancethicknessSolution')
-				md = checkfield(md,'fieldname','inversion.thickness_obs','size',[md.mesh.numberofvertices 1],'NaN',1,'Inf',1);
-				md = checkfield(md,'fieldname','inversion.surface_obs','size',[md.mesh.numberofvertices 1],'NaN',1,'Inf',1);
+				md = checkfield(md,'fieldname','md.outputdefinition.definition{X}.thickness_obs','field',self.thickness_obs,'size',[md.mesh.numberofvertices 1],'NaN',1,'Inf',1);
+				md = checkfield(md,'fieldname','md.outputdefinition.definition{X}.surface_obs','field',self.surface_obs,'size',[md.mesh.numberofvertices 1],'NaN',1,'Inf',1);
 			elseif strcmp(solution,'BalancethicknessSoftSolution')
-				md = checkfield(md,'fieldname','inversion.thickness_obs','size',[md.mesh.numberofvertices 1],'NaN',1,'Inf',1);
+				md = checkfield(md,'fieldname','md.outputdefinition.definition{X}.thickness_obs','field',self.thickness_obs,'size',[md.mesh.numberofvertices 1],'NaN',1,'Inf',1);
 			else
-				md = checkfield(md,'fieldname','inversion.vx_obs','size',[md.mesh.numberofvertices 1],'NaN',1,'Inf',1);
+				md = checkfield(md,'fieldname','md.outputdefinition.definition{X}.vx_obs','field',self.vx_obs,'size',[md.mesh.numberofvertices 1],'NaN',1,'Inf',1);
 				if ~strcmp(domaintype(md.mesh),'2Dvertical'),
-					md = checkfield(md,'fieldname','inversion.vy_obs','size',[md.mesh.numberofvertices 1],'NaN',1,'Inf',1);
+					md = checkfield(md,'fieldname','md.outputdefinition.definition{X}.vy_obs','field',self.vy_obs,'size',[md.mesh.numberofvertices 1],'NaN',1,'Inf',1);
 				end
 			end
Index: issm/trunk/src/m/classes/taoinversion.py
===================================================================
--- issm/trunk/src/m/classes/taoinversion.py	(revision 23389)
+++ issm/trunk/src/m/classes/taoinversion.py	(revision 23394)
@@ -97,5 +97,5 @@
 		else:
 			self.algorithm = 'tao_blmvm';
-		
+
 		#several responses can be used:
 		self.cost_functions=101;
@@ -110,8 +110,8 @@
 		if numel(self.cost_functions_coefficients) > 1:
 			self.cost_functions_coefficients=project3d(md,'vector',self.cost_functions_coefficients,'type','node')
-		
+
 		if numel(self.min_parameters) > 1:
 			self.min_parameters=project3d(md,'vector',self.min_parameters,'type','node')
-		
+
 		if numel(self.max_parameters)>1:
 			self.max_parameters=project3d(md,'vector',self.max_parameters,'type','node')
@@ -123,5 +123,5 @@
 			return md
 		if not IssmConfig('_HAVE_TAO_')[0]:
-			md = checkmessage(md,['TAO has not been installed, ISSM needs to be reconfigured and recompiled with TAO'])
+			md = md.checkmessage('TAO has not been installed, ISSM needs to be reconfigured and recompiled with TAO')
 
 
Index: issm/trunk/src/m/contrib/defleurian/netCDF/export_netCDF.py
===================================================================
--- issm/trunk/src/m/contrib/defleurian/netCDF/export_netCDF.py	(revision 23389)
+++ issm/trunk/src/m/contrib/defleurian/netCDF/export_netCDF.py	(revision 23394)
@@ -18,5 +18,5 @@
 			print ('New file name is {}'.format(newname))
 			filename=newname
-			
+
 	NCData=Dataset(filename, 'w', format='NETCDF4')
 	NCData.description = 'Results for run' + md.miscellaneous.name
@@ -100,10 +100,10 @@
 				Subgroup.__setattr__('classtype',md.__dict__[group].__class__.__name__)
 				subfields=dict.keys(md.__dict__[group].__dict__[field].__dict__)
-                                
+
 				for subfield in subfields:
 					if str(subfield)!='outlog':
 						Var=md.__dict__[group].__dict__[field].__dict__[subfield]
 						DimDict=CreateVar(NCData,Var,subfield,Subgroup,DimDict)
-				
+
 	NCData.close()
 
@@ -130,9 +130,10 @@
 							str:str,
 							dict:str}
-		
+
 	val_dim=np.shape(val_shape)[0]
+
 	#Now define and fill up variable
 	#treating scalar string or bool as atribute
-	if val_type==str or val_type==unicode or val_type==bool:
+	if val_type in [str,unicode,bool]:
 		Group.__setattr__(str(field).swapcase(), str(var))
 	#treating list as string table
@@ -147,5 +148,5 @@
 		if val_shape==0:
 			ncvar= []
-		else:			
+		else:
 			for elt in range(0,val_shape[0]):
 				ncvar[elt] = var[elt]
@@ -164,5 +165,5 @@
 			ncvar[elt,1]=str(dict.values(var)[elt]) #converting to str to avoid potential problems
 	#Now dealing with numeric variables
-	else:
+	elif val_type in [float,'float64',np.float64,int,'int64']:
 		dimensions,DimDict=GetDim(NCData,var,val_shape,DimDict,val_dim)
 		ncvar = Group.createVariable(str(field),TypeDict[val_type],dimensions,zlib=True)
@@ -175,4 +176,6 @@
 		except TypeError: #type does not accept nan, get vallue of the variable
 			ncvar[:] = var
+	else:
+		print('WARNING type "{}" is unknown for "{}.{}"'.format(val_type,Group.name,field))
 	return DimDict
 
